<?php
/**
 * All-in-One WP Migration
 * Copyright (C) 2014-2018 ServMask Inc.
 *
 * Modified Copyright (C) 2025 Lead Connector
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

if ( ! defined( 'ABSPATH' ) ) {
	die( 'Well Sir You Cannot Jump Here...haha' );
}

class Lcm_Import_Confirm {

	public static function execute( $params ) {

		$messages = array();

		// Read package.json file
		$handle = lcm_open( lcm_package_path( $params ), 'r' );

		// Parse package.json file
		$package = lcm_read( $handle, filesize( lcm_package_path( $params ) ) );
		$package = json_decode( $package, true );

		// Close handle
		lcm_close( $handle );

		// Confirm message
		$messages[] = __(
			'Importing this file will only replace matching content. Other items stay unchanged. Ensure you have a current backup. Proceed?',
			'lc-migrator'
		);

		// Check compatibility of PHP versions
		if ( isset( $package['PHP']['Version'] ) ) {
			// Extract major and minor version numbers
			$source_versions = explode( '.', $package['PHP']['Version'] );
			$target_versions = explode( '.', PHP_VERSION );

			$source_major_version = intval( $source_versions[0] );
			$source_minor_version = intval( isset( $source_versions[1] ) ? $source_versions[1] : 0 );

			$target_major_version = intval( $target_versions[0] );
			$target_minor_version = intval( isset( $target_versions[1] ) ? $target_versions[1] : 0 );

			if ( $source_major_version !== $target_major_version ) {
				$from_php = $source_major_version;
				$to_php   = $target_major_version;
			} elseif ( $source_minor_version !== $target_minor_version ) {
				$from_php = sprintf( '%s.%s', $source_major_version, $source_minor_version );
				$to_php   = sprintf( '%s.%s', $target_major_version, $target_minor_version );
			}

			if ( isset( $from_php, $to_php ) ) {
				$messages[] = sprintf(
					/* translators: 1: Source PHP version, 2: Target PHP version. */
					__(
						'Your backup is from PHP %1$s but the site you are importing to is PHP %2$s. This could cause the import to fail.',
						'lc-migrator'
					),
					$from_php,
					$to_php
				);
			}
		}

		if ( defined( 'WP_CLI' ) ) {
			$assoc_args = array();
			if ( isset( $params['cli_args'] ) ) {
				$assoc_args = $params['cli_args'];
			}

			WP_CLI::confirm( implode( PHP_EOL, $messages ), $assoc_args );

			return $params;
		}

		// Set progress
		Lcm_Status::confirm( implode( $messages ) );
		exit;
	}
}
